from qt import *
import windowbase
import sys
from math import *

# Thanks for the item code to whoever wrote 
# http://www.diotavelli.net/PyQtWiki/CustomListViewItems

counter=0

class vItem(QListViewItem):

    normal_brush = QBrush(Qt.white)
    def __init__(self,parent,value,bold=False,right=False,color=QColor(0,0,0)):
        global counter
        self.right=right
        self.color=color
        self.order=counter
        QListViewItem.__init__(self,parent)
        counter=counter+1
        self.brush = self.normal_brush
        self.font=self.listView().font()
        if bold:
            self.font.setBold(True)
        self.setText(0,str(value))
    
    def key(self,column,ascending):
        return "%09d"%self.order

    def width (self,fm,lv,c):
        return QFontMetrics(self.font).size(Qt.SingleLine,self.text(0)).width()+4
        
    def paintCell(self, painter, colour_group, column, width, alignment): 
        painter.save()
        painter.fillRect(0, 0, width, self.height(), self.brush)
        painter.setFont(self.font)
        painter.setPen(QPen(self.color))
        if self.right:
            l=width-QFontMetrics(self.font).size(Qt.SingleLine,self.text(column)).width()-4
        else:
            l=0
        painter.drawText(l,QFontMetrics(self.font).ascent(), self.text(column))
        painter.restore()     
        
class Window (windowbase.WindowBase):
        def __init__(self,parent=0):
            windowbase.WindowBase.__init__(self)
            self.line.setFocus()
            self.c=0
            
        def evaluate(self):
            s=str(self.line.text())
            if len(s.strip())==0:
                return
            self.line.clear()

            self.list.ensureItemVisible(vItem(self.list,s))
            try:
                res=eval(s)
                self.list.ensureItemVisible(vItem(self.list,res,bold=True,right=True))
            except:
                (type,res,trace)=sys.exc_info()
                self.list.ensureItemVisible(vItem(self.list,res,bold=True,right=True,color=QColor(255,0,0)))
            
            
            
            print res
            
        def insertValue(self,item):
            self.line.insert(item.text(0))
            self.line.setFocus()
